package com.company.sms.service;

import com.company.sms.entity.SmsRequestDto;
import com.company.sms.entity.SmsRequestEntity;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.List;

@Component("sms_SmsServiceBean")
public class SmsServiceBean {

    private static final String SMS_API_URL = "https://corpsms.banglalink.net/bl/api/v1/smsapigw/";
    private static final String USERNAME = "xxxxxx";
    private static final String PASSWORD = "yyyyyyyy";

    private static final String BillMSISDN = "01969981234";

    @Autowired
    private DataManager dataManager;

    private final RestTemplate restTemplate;

    public SmsServiceBean(RestTemplateBuilder restTemplateBuilder) {
        this.restTemplate = restTemplateBuilder.build();
    }

    public void sendAllSmsFromDatabase(){
/*
        final List<SmsRequestEntity> smsRequestEntityList = dataManager.load(SmsRequestEntity.class)
                .query("select s from sms_SmsRequestEntity s")
                .list();
*/
        SmsRequestDto smsRequestDto = new SmsRequestDto();
        smsRequestDto.setUsername(USERNAME);
        smsRequestDto.setPassword(PASSWORD);
        smsRequestDto.setApicode("5");
        smsRequestDto.setMsisdn("1710817997");
        smsRequestDto.setCountrycode("880");
        smsRequestDto.setCli("Test");
        smsRequestDto.setMessagetype("1");
        smsRequestDto.setMessage("TEST SMS");
        smsRequestDto.setClienttransid("11111a1111b11");
        smsRequestDto.setBillMsisdn(BillMSISDN);
        smsRequestDto.setTranType("T");
        smsRequestDto.setRequestType("S");
        smsRequestDto.setRnCode("91");

        sendSms(smsRequestDto);
    }

    public void sendSms(SmsRequestDto smsRequestDto) {
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        headers.setBasicAuth(USERNAME, PASSWORD);

        HttpEntity<SmsRequestDto> request = new HttpEntity<>(smsRequestDto, headers);

        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<String> response = restTemplate.postForEntity(SMS_API_URL, request, String.class);

        String responseBody = response.getBody();
        // Process the API response as needed
    }



}